﻿Imports System
Imports System.Text
Imports System.Threading

Public Class Form1

    Dim globalPacket As New Packet
    Dim nodeCollection As TreeNodeCollection
    Private Delegate Sub MyDelSub()


    ' The ExamineBit function will return True or False
    ' depending on the value of the 1 based, nth bit (MyBit)
    ' of an integer (MyByte).
    Function ExamineBit(ByVal MyByte, ByVal MyBit) As Boolean
        Dim BitMask As Int16
        BitMask = 2 ^ (MyBit - 1)
        ExamineBit = ((MyByte And BitMask) > 0)
    End Function
    ' The SetBit Sub will set the 1 based, nth bit
    ' (MyBit) of an integer (MyByte).
    Sub SetBit(ByRef MyByte, ByVal MyBit)
        Dim BitMask As Int16
        BitMask = 2 ^ (MyBit - 1)
        MyByte = MyByte Or BitMask
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        txtLog.CheckForIllegalCrossThreadCalls = False
        bgwCheckSerialBuffer.RunWorkerAsync()
        'trvXbeeNodes.CheckForIllegalCrossThreadCalls = False
        txtNodeList.CheckForIllegalCrossThreadCalls = False
        'txtFinalPacket.CheckForIllegalCrossThreadCalls = False

    End Sub

    Private Sub btnLoadXbeeNodes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadXbeeNodes.Click
        txtNodeList.Text = ""
        If SerialPort1.IsOpen Then

            Dim TestData(8) As Byte ' = {&HFE, &H11, &H11, &HFF}

            'Dim TestData(3) As Byte
            TestData(0) = &H7E
            TestData(1) = &H0
            TestData(2) = &H4
            TestData(3) = &H8
            TestData(4) = &H1
            TestData(5) = &H4E
            TestData(6) = &H44
            TestData(7) = &H64

            SerialPort1.Write(TestData, 0, 8)

            'MsgBox("SentData")

        End If
    End Sub

    Private Sub btnComOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnComOpen.Click
        If SerialPort1.IsOpen Then
            'The port is already open, so close it
            SerialPort1.Close()
            btnComOpen.Text = "Open Port"
        Else
            'The port is closed, open it
            SerialPort1.PortName = txtComPort.Text
            SerialPort1.Open()
            btnComOpen.Text = "Close Port"
        End If
    End Sub

    Private Sub btnSendTestSerial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendTestSerial.Click
        If SerialPort1.IsOpen Then

            Dim TestData(25) As Byte ' = {&HFE, &H11, &H11, &HFF}

            'Dim TestData(3) As Byte
            TestData(0) = &H7E
            TestData(1) = &H0
            TestData(2) = &H16
            TestData(3) = &H10
            TestData(4) = &H1
            TestData(5) = &H0
            TestData(6) = &H13
            TestData(7) = &HA2
            TestData(8) = &H0
            TestData(9) = &H40
            TestData(10) = &HA
            TestData(11) = &H3E
            TestData(12) = &HB6
            TestData(13) = &HFF
            TestData(14) = &HFE
            TestData(15) = &H0
            TestData(16) = &H0
            TestData(17) = &H54
            TestData(18) = &H78
            TestData(19) = &H44
            TestData(20) = &H61
            TestData(21) = &H74
            TestData(22) = &H61
            TestData(23) = &H30
            TestData(24) = &H41
            TestData(25) = &H47

            SerialPort1.Write(TestData, 0, 26)

            'MsgBox("SentData")

        End If
    End Sub

    ' Converts a hexadecimal string to a byte .
    Private Function HexToByte(ByVal hexString As String) As Byte
        Dim returnByte As Byte

        'Test if hexString.Length <>2
        If hexString.Length <> 2 Then
            MsgBox("You have an error for " & hexString & " value")

            Return CByte(&H1) 'By default

        End If

        returnByte = Convert.ToByte(hexString.Substring(0, 2), 16)


        Return returnByte
    End Function 'HexToByte

    Private Function updateXbeeNodeList()
        For Each node In nodeCollection
            'trvXbeeNodes.Nodes.Add(node)
        Next
    End Function

    Public Shared Function StrToByteArray(ByVal str As String) As Byte()
        Dim encoding As New System.Text.ASCIIEncoding()
        Return encoding.GetBytes(str)
    End Function 'StrToByteArray

    Private Sub bgwCheckSerialBuffer_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles bgwCheckSerialBuffer.DoWork
        'Dim del As MyDelSub
        'del = New MyDelSub(AddressOf updateXbeeNodeList)
        Dim currByte As Byte
        Dim bytesLeft As Integer = 0

        Dim atCommand As String = ""
        Dim RNA(2) As Byte
        Dim serialNumber(8) As Byte
        Dim NI As String = ""
        Dim i As Integer = 0 'A counter for NI
        Dim parentMY(2) As Byte
        Dim deviceType As Integer = -1
        Dim status As Integer = -1
        Dim profileID(2) As Byte
        Dim ManID(2) As Byte

        While 1
            Try
                If SerialPort1.IsOpen Then
                    currByte = SerialPort1.ReadByte
                    If globalPacket.stage = 0 Then          'Packet isn't initalized yet
                        If currByte = 126 Then              'We got a packet starter
                            globalPacket.stage = 1          'The packet is now init
                        Else
                            SerialPort1.DiscardInBuffer()   'We got ourselves an error, flush all the incoming shit
                        End If
                    ElseIf globalPacket.stage = 1 Then      'Packet is initalized, this SHOULD be the length's MSB
                        globalPacket.stage = 2
                    ElseIf globalPacket.stage = 2 Then      'We've got the packet's MSB, this should be the packet's LSB
                        globalPacket.stage = 3
                        globalPacket.length = currByte
                        bytesLeft = currByte
                    ElseIf globalPacket.stage = 3 Then      'We've got the packet's data's length, this should be the API ID
                        globalPacket.stage = 4
                        globalPacket.apiID = currByte
                        txtLog.Text += "[START PACKET]" + vbCrLf
                        deviceType = -1
                        status = -1

                        atCommand = ""
                        NI = ""
                        i = 0
                        'bytesLeft -= 1
                    ElseIf globalPacket.stage >= 4 Then      'We've got the packet's API Identifier, start a new packet based on that
                        Select Case globalPacket.apiID
                            Case 139
                                'We've got a Transmit Status Packet! Store shit
                                If globalPacket.stage = 4 Then
                                    'This should be the FrameID
                                    txtLog.Text += "--FrameID: " + currByte.ToString + vbCrLf
                                ElseIf globalPacket.stage = 5 Then
                                    'This should be the remote network address MSB
                                    txtLog.Text += "--RNA[MSB]: " + currByte.ToString + vbCrLf
                                ElseIf globalPacket.stage = 6 Then
                                    'This should be the remote network address LSB
                                    txtLog.Text += "--RNS[LSB]: " + currByte.ToString + vbCrLf
                                ElseIf globalPacket.stage = 7 Then
                                    'Delivery Status
                                    txtLog.Text += "--Delivery Status: " + currByte.ToString + vbCrLf
                                ElseIf globalPacket.stage = 8 Then
                                    'Discovery Status
                                    txtLog.Text += "--Discovery Status: " + currByte.ToString + vbCrLf
                                Else
                                    'Checksum, Packet is done
                                    globalPacket.stage = -1
                                    txtLog.Text += "[END PACKET]" + vbCrLf
                                End If
                            Case 136

                                'We've got a AT Command Response
                                If globalPacket.stage = 4 Then
                                    'This should be the FrameID
                                    txtLog.Text += "--FrameID: " + currByte.ToString + vbCrLf
                                ElseIf globalPacket.stage = 5 Then
                                    'This should be the AT Command's first character
                                    atCommand += Chr(currByte)
                                    'txtLog.Text += "--Test2: " + atCommand + vbCrLf
                                ElseIf globalPacket.stage = 6 Then
                                    'This should be the AT Command's second character
                                    atCommand += Chr(currByte)
                                    txtLog.Text += "--AT Command: " + atCommand + vbCrLf
                                ElseIf globalPacket.stage = 7 Then
                                    'This should be the status(0  = Ok, 1 = ERROR, 2 = Invalid Command, 3 = Invalid Parameter)
                                    txtLog.Text += "--Status: " + Chr(currByte) + vbCrLf
                                ElseIf globalPacket.stage >= 8 Then
                                    'This should all be data
                                    Select Case atCommand
                                        Case "ND"
                                            If globalPacket.length < 12 Then
                                                txtLog.Text += "--End Of ND Stream" + vbCrLf
                                                globalPacket.stage = -1
                                                Exit Select

                                            End If
                                            If globalPacket.stage = 8 Then
                                                'This should be the remote network address 16bit
                                                RNA(0) = currByte
                                                txtLog.Text += "Got RNA(0)" + vbCrLf
                                            ElseIf globalPacket.stage = 9 Then
                                                RNA(1) = currByte
                                                txtLog.Text += "Got RNA(1)" + vbCrLf
                                            ElseIf globalPacket.stage = 10 Then
                                                'This should be the remote network address 64bit
                                                serialNumber(0) = currByte
                                                txtLog.Text += "Got serialNumber(0)" + vbCrLf
                                            ElseIf globalPacket.stage = 11 Then
                                                serialNumber(1) = currByte
                                                txtLog.Text += "Got serialNumber(1)" + vbCrLf
                                            ElseIf globalPacket.stage = 12 Then
                                                serialNumber(2) = currByte
                                                txtLog.Text += "Got serialNumber(2)" + vbCrLf
                                            ElseIf globalPacket.stage = 13 Then
                                                serialNumber(3) = currByte
                                                txtLog.Text += "Got serialNumber(3)" + vbCrLf
                                            ElseIf globalPacket.stage = 14 Then
                                                serialNumber(4) = currByte
                                                txtLog.Text += "Got serialNumber(4)" + vbCrLf
                                            ElseIf globalPacket.stage = 15 Then
                                                serialNumber(5) = currByte
                                                txtLog.Text += "Got serialNumber(5)" + vbCrLf
                                            ElseIf globalPacket.stage = 16 Then
                                                serialNumber(6) = currByte
                                                txtLog.Text += "Got serialNumber(6)" + vbCrLf
                                            ElseIf globalPacket.stage = 17 Then
                                                serialNumber(7) = currByte
                                                txtLog.Text += "Got serialNumber(7)" + vbCrLf
                                            ElseIf globalPacket.stage >= 18 Then
                                                'We are now in the "NI" or Node Identifier data. This data is terminated with a "00" or 
                                                If i > 0 Then
                                                    txtLog.Text += "We are past the NI" + vbCrLf
                                                    'We are outside the NI
                                                    If globalPacket.stage = 18 + i Then
                                                        'Parent MY MSB
                                                        parentMY(0) = currByte
                                                    ElseIf globalPacket.stage = 18 + i + 1 Then
                                                        'Parent MY LSB
                                                        parentMY(1) = currByte
                                                    ElseIf globalPacket.stage = 18 + i + 2 Then
                                                        'Device Type
                                                        deviceType = currByte
                                                    ElseIf globalPacket.stage = 18 + i + 3 Then
                                                        'Status
                                                        status = currByte
                                                    ElseIf globalPacket.stage = 18 + i + 4 Then
                                                        'Profile ID
                                                        profileID(0) = currByte
                                                    ElseIf globalPacket.stage = 18 + i + 5 Then
                                                        'Profile ID
                                                        profileID(1) = currByte
                                                    ElseIf globalPacket.stage = 18 + i + 6 Then
                                                        'Manufacturer ID
                                                        ManID(0) = currByte
                                                    ElseIf globalPacket.stage = 18 + i + 7 Then
                                                        'Manufacturer ID
                                                        ManID(1) = currByte
                                                    ElseIf globalPacket.stage = 18 + i + 8 Then
                                                        'Checksum
                                                        'Time to generate a NODE:
                                                        'Note Name(NI)
                                                        '--Device Type
                                                        '--Status
                                                        '--Address:
                                                        '----16Bit Add
                                                        '----64Bit Add
                                                        '--Other:
                                                        '----Parent MY
                                                        '----Profile ID
                                                        '----Man ID

                                                        'Me.Invoke(trvXbeeNodes.Nodes.Add(NI))



                                                        Dim str16BitAddress = Hex(RNA(0)) + Hex(RNA(1))
                                                        Dim str64BitAddress = Hex(serialNumber(0)) + Hex(serialNumber(1)) + Hex(serialNumber(2)) + Hex(serialNumber(3)) + Hex(serialNumber(4)) + Hex(serialNumber(5)) + Hex(serialNumber(6)) + Hex(serialNumber(7))
                                                        Dim strParentMY = Hex(parentMY(0)) + Hex(parentMY(1))
                                                        Dim strProfileID = Hex(profileID(0)) + Hex(profileID(1))
                                                        Dim strManID = Hex(ManID(0)) + Hex(ManID(1))


                                                        txtNodeList.Text += "Node:" + NI + vbCrLf
                                                        txtNodeList.Text += "-Type:" + deviceType.ToString + vbCrLf
                                                        txtNodeList.Text += "-Status:" + status.ToString + vbCrLf
                                                        txtNodeList.Text += "-Identity:" + status.ToString + vbCrLf
                                                        txtNodeList.Text += "--16Bit:" + str16BitAddress + vbCrLf
                                                        txtNodeList.Text += "--64Bit:" + str64BitAddress + vbCrLf
                                                        txtNodeList.Text += "-Other:" + vbCrLf
                                                        txtNodeList.Text += "--Parent MY:" + strParentMY + vbCrLf
                                                        txtNodeList.Text += "--Profile ID:" + strProfileID + vbCrLf
                                                        txtNodeList.Text += "--Man ID:" + strManID + vbCrLf + "-------------" + vbCrLf

                                                        globalPacket.stage = -1
                                                    End If
                                                Else
                                                    'We are inside the NI
                                                    If currByte = &H0 Then
                                                        'This is the End Deliminater of the NI
                                                        i = globalPacket.stage - 17
                                                        txtLog.Text += "Found the end of the NI, I is:" + i.ToString + vbCrLf
                                                    Else
                                                        txtLog.Text += "Got some NI data" + vbCrLf
                                                        NI += Chr(currByte)
                                                    End If
                                                End If



                                            End If
                                        Case Else
                                            globalPacket.stage = -1
                                    End Select

                                End If
                        End Select
                        globalPacket.stage += 1
                    End If
                End If
            Catch ex As Exception
                'Screw the error
            End Try
        End While
    End Sub

    Private Sub btnGenerateChecksum_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGenerateChecksum.Click
        If SerialPort1.IsOpen Then

            Dim TestData(89) As Byte
            Dim dataLength As Integer = 0

            'Length = 14 + Len of Data
            TestData(0) = &H7E                      'Starting Deliminator

            TestData(1) = &H0                       'Length MSB
            'TestData(2) = &H16                      'Length LSB

            dataLength = StrToByteArray(txtMessage.Text).Count
            TestData(2) = 15 + StrToByteArray(txtMessage.Text).Count

            TestData(3) = &H10                      'API Identifier
            TestData(4) = &H1                       'Frame ID

            If Len(txt64Address.Text) = 16 Then
                For i As Integer = 0 To 7
                    TestData(5 + i) = HexToByte(Mid(txt64Address.Text, i * 2 + 1, 2))

                    'MsgBox("TestData(" + (5 + i).ToString + "):" + Mid(txt64Address.Text, i * 2 + 1, 2))

                Next
            Else
                MsgBox("You have entered an invalid 64bit Address! Please check your 64bit address and try again")
                End
            End If

            TestData(13) = &HFF                     '16bit Address(Keep As Is)
            TestData(14) = &HFE                     '16bit Address(Keep as Is)
            TestData(15) = &H0                      '# of Hopes
            TestData(16) = &H0                      'Unicast Transmission


            Dim byteArray() As Byte
            byteArray = StrToByteArray(txtMessage.Text)
            For i As Integer = 0 To byteArray.Count - 1
                TestData(17 + i) = byteArray(i)
            Next
            'TestData(25) = &H47                     'Checksum

            'Checksum
            Dim checksum As Integer = &HFF
            For i As Integer = 3 To 17 + dataLength
                'MsgBox(i.ToString + "Current Checksum:" + Hex(checksum) + vbCrLf + "Current Byte Data:" + Hex(TestData(i)) + vbCrLf + "The subtraction:" + Hex(checksum - TestData(i)))

                checksum -= TestData(i)
            Next

            'MsgBox(Mid(Hex(checksum), Hex(checksum).Length - 1, 2))
            TestData(18 + dataLength) = HexToByte(Mid(Hex(checksum), Hex(checksum).Length - 1, 2))
            'TestData(18 + dataLength) = CByte(checksum) 'Convert.ToByte(checksum)

            Dim txtFullPacket As String = ""
            For i As Integer = 0 To 18 + dataLength
                txtFullPacket += Hex(TestData(i)) + " "
            Next
            'txtFinalPacket.Text = txtFullPacket

            SerialPort1.Write(TestData, 0, 19 + dataLength)

        End If
    End Sub


    Private Sub btnControlV1Update_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnControlV1Update.Click
        fnControlV1Update()
    End Sub

    Public Function fnControlV1Update()
        Dim testByte As Byte = &H0
        If chkControlV1Sw1.Checked = True Then
            SetBit(testByte, 1)
        End If
        If chkControlV1Sw2.Checked = True Then
            SetBit(testByte, 2)
        End If
        If chkControlV1Sw3.Checked = True Then
            SetBit(testByte, 3)
        End If
        If chkControlV1Sw4.Checked = True Then
            SetBit(testByte, 4)
        End If
        If chkControlV1Sw5.Checked = True Then
            SetBit(testByte, 5)
        End If
        If chkControlV1Sw6.Checked = True Then
            SetBit(testByte, 6)
        End If
        If chkControlV1Sw7.Checked = True Then
            SetBit(testByte, 7)
        End If
        If chkControlV1Sw8.Checked = True Then
            SetBit(testByte, 8)
        End If

        'MsgBox(testByte)






        If SerialPort1.IsOpen Then

            Dim TestData(89) As Byte
            Dim dataLength As Integer = 0

            'Length = 14 + Len of Data
            TestData(0) = &H7E                      'Starting Deliminator

            TestData(1) = &H0                       'Length MSB
            'TestData(2) = &H16                      'Length LSB

            'dataLength = StrToByteArray(txtMessage.Text).Count
            TestData(2) = 16 ' + StrToByteArray(txtMessage.Text).Count

            TestData(3) = &H10                      'API Identifier
            TestData(4) = &H1                       'Frame ID

            If Len(txtControlV164BitAddress.Text) = 16 Then
                For i As Integer = 0 To 7
                    TestData(5 + i) = HexToByte(Mid(txt64Address.Text, i * 2 + 1, 2))

                    'MsgBox("TestData(" + (5 + i).ToString + "):" + Mid(txt64Address.Text, i * 2 + 1, 2))

                Next
            Else
                MsgBox("You have entered an invalid 64bit Address! Please check your 64bit address and try again")
                End
            End If

            TestData(13) = &HFF                     '16bit Address(Keep As Is)
            TestData(14) = &HFE                     '16bit Address(Keep as Is)
            TestData(15) = &H0                      '# of Hopes
            TestData(16) = &H0                      'Unicast Transmission

            TestData(17) = &H64
            TestData(18) = testByte
            'Dim byteArray() As Byte

            'byteArray = StrToByteArray(txtMessage.Text)
            'For i As Integer = 0 To byteArray.Count - 1
            ' TestData(17 + i) = byteArray(i)
            'Next
            'TestData(25) = &H47                     'Checksum

            'Checksum
            Dim checksum As Integer = &HFF
            For i As Integer = 3 To 18
                'MsgBox(i.ToString + "Current Checksum:" + Hex(checksum) + vbCrLf + "Current Byte Data:" + Hex(TestData(i)) + vbCrLf + "The subtraction:" + Hex(checksum - TestData(i)))

                checksum -= TestData(i)
            Next

            'MsgBox(Mid(Hex(checksum), Hex(checksum).Length - 1, 2))
            TestData(19) = HexToByte(Mid(Hex(checksum), Hex(checksum).Length - 1, 2))
            'TestData(18 + dataLength) = CByte(checksum) 'Convert.ToByte(checksum)

            Dim txtFullPacket As String = ""
            For i As Integer = 0 To 19
                txtFullPacket += Hex(TestData(i)) + " "
            Next
            'MsgBox(txtFullPacket)

            SerialPort1.Write(TestData, 0, 20)

        End If
    End Function
    Private Sub chkControlV1Sw1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkControlV1Sw1.CheckedChanged
        If chkControlV1AutoUpdate.Checked Then
            fnControlV1Update()
        End If
    End Sub

    Private Sub chkControlV1Sw2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkControlV1Sw2.CheckedChanged
        If chkControlV1AutoUpdate.Checked Then
            fnControlV1Update()
        End If
    End Sub

    Private Sub chkControlV1Sw3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkControlV1Sw3.CheckedChanged
        If chkControlV1AutoUpdate.Checked Then
            fnControlV1Update()
        End If
    End Sub

    Private Sub chkControlV1Sw4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkControlV1Sw4.CheckedChanged
        If chkControlV1AutoUpdate.Checked Then
            fnControlV1Update()
        End If
    End Sub

    Private Sub chkControlV1Sw5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkControlV1Sw5.CheckedChanged
        If chkControlV1AutoUpdate.Checked Then
            fnControlV1Update()
        End If
    End Sub

    Private Sub chkControlV1Sw6_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkControlV1Sw6.CheckedChanged
        If chkControlV1AutoUpdate.Checked Then
            fnControlV1Update()
        End If
    End Sub

    Private Sub chkControlV1Sw7_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkControlV1Sw7.CheckedChanged
        If chkControlV1AutoUpdate.Checked Then
            fnControlV1Update()
        End If
    End Sub

    Private Sub chkControlV1Sw8_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkControlV1Sw8.CheckedChanged
        If chkControlV1AutoUpdate.Checked Then
            fnControlV1Update()
        End If
    End Sub
End Class
Public Class Packet
    Public stage As Integer = 0 '0 = No Start, 1 = Len MSB, 2 = Len LSB, 3 = API ID, 4 = Data(Depends on apiID)
    Public apiID As Integer = 0
    Public length As Integer = 0
    Public data(72) As Byte
End Class

Public Class TxStatusPacket 'API ID of &H8B
    Public remoteAddress(2) As Byte
    Public retryCount As Integer = -1
    Public DeliveryStatus As Integer = -1
    Public DiscoveryStatus As Integer = -1
End Class